package com.zksy.controller.info;

import cn.hutool.core.date.DateTime;
import com.zksy.info.domain.EEmployeeInfo;
import com.zksy.info.domain.EEmployeeMaster;
import com.zksy.info.service.EEmployeeInfoService;
import com.zksy.property.domain.AHouseType;
import com.zksy.property.service.AHouseTypeService;
import com.zksy.utils.AjaxResult;
import com.zksy.utils.ExcelExportUtil;
import com.zksy.utils.ExcelImportUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.time.LocalDate;
import java.time.LocalDateTime;

/**
 * @author Administrator
 * @version 1.0
 * @project enterprise-assets-service
 * @description 员工基本信息控制层
 * @date 2025/6/24 14:33:13
 */
@RestController
@RequestMapping("/eemployeeInfo")
@Api(tags = "员工基本信息控制层",description = "员工基本信息控制层desc")
public class EEmployeeInfoController {
    @Autowired
    private EEmployeeInfoService service;
    @GetMapping("/getById/{id}")
    @ApiOperation(value = "员工基本信息查询")
    public AjaxResult getById(@PathVariable String id) {
        return AjaxResult.success(service.getById(id));
    }
    @GetMapping("/getList")
    @ApiOperation(value = "员工基本信息查询所有")
    public AjaxResult getList(String workNumber,String fullName) {
        return AjaxResult.success(service.getEEmployeeInfoList(workNumber, fullName));
    }
    @GetMapping("/findByPage")
    @ApiOperation(value = "员工基本信息查询分页")
    public AjaxResult findByPage(long pageNum, long pageSize, String workNumber,String fullName){
        return AjaxResult.success(service.findByPage(pageNum, pageSize, workNumber, fullName));
    }
    @PostMapping("/save")
    @ApiOperation(value = "员工基本信息保存")
    public AjaxResult save(@RequestBody EEmployeeInfo eemployeeInfo, MultipartFile multipartFile) {
        return service.saveEEmployeeInfo(eemployeeInfo, multipartFile)? AjaxResult.success(eemployeeInfo): AjaxResult.error("保存失败");
    }
    @PostMapping("/update")
    @ApiOperation(value = "员工基本信息修改")
    public AjaxResult update(@RequestBody EEmployeeInfo eemployeeInfo, MultipartFile multipartFile) {
        eemployeeInfo.setUpdateTime(LocalDateTime.now());
        return service.updateEEmployeeInfo(eemployeeInfo, multipartFile)? AjaxResult.success(eemployeeInfo): AjaxResult.error("修改失败");
    }
    @PostMapping("/deleteBatch")
    @ApiOperation(value = "员工基本信息删除")
    public AjaxResult delete(@RequestBody String[] ids) {
        return service.removeBatchEEmployeeInfo(ids)? AjaxResult.success("删除成功"): AjaxResult.error("删除失败");
    }
    @PostMapping("/importData")
    @ApiOperation(value = "导入数据")
    public AjaxResult importData(MultipartFile file) {
        return AjaxResult.success(service.saveOrUpdateBatch(ExcelImportUtil.importExcel(file, EEmployeeInfo.class)));
    }
    @GetMapping("/exportData")
    @ApiOperation(value = "导出数据")
    public void exportData(HttpServletResponse response, String workNumber,String fullName) {
         ExcelExportUtil.exportExcel(response,service.getEEmployeeInfoList(workNumber,fullName), EEmployeeInfo.class, "员工基本信息","员工基本信息");
    }
}
